EDIT - feature request #7063

Improve the area selection wizard for distribution editor
11/07/2017 11:54 AM - Katja Luther
Category: taxeditor Estimated time: 8:00 hours
Target version: Release 5.4

Severity: normal

Description

The wizard for selection of areas for the distribution editor should be improved.

e while opening the wizard the vocabularies are not correctly marked if the whole vocabulary or only parts of it should be used in
the distribution editor.
e the wizard is quite slow (performance)

For the first issue we decided to implement the following:

1. we keep selection via tree structure
2. the checkbox uses triple state:  a. checked, if, and only if, all subareas, and their subareas are fully included
o undefined, if, some subareas are checked, but not all (including recursive subareas
o not checked, if no of the subareas is checked or in "undefinded" state it self
3. opening a node in the tree works via "triangle button"
4. click actions: double functionality is needed
o select/deselect all subareas
o select the given area (not including the subareas)
o problem: we want to avoid right click menus or other double functionality handling modes (e.g. single click/double click) as
they are maybe not intuitive
o solution: to select/deselect the single area (without subareas) we add it to itself as child node at first position, without
children
5. click action "select all subareas" will
o open the for one more level
o check the parent checkbox and all child checkboxes
o check all grandchild checkboxes if expanded, however for all grand(grand) children the information needs to be stored that
they are "checked"
o opening also all grandchildren takes a lot of rendering time and is not necessary
6. click "deselect all" will
o unckeck all child and grandchild areas
o not change the expansion state of the tree

For performance improvement need something like a UuidAndTitleCache for trees (including the parent information). Loading this
should be faster then current implementation but can still load the full vocabulary at once if voc is not extremely large. But maybe this
already exists e.g. from taxon navigator DTO.

Open issues:

e triple state is not yet correctly propagated to vocabulary during initial load (checkbox always empty)

¢ deselection only propagates to next parent, but not to grandparent (e.g. if parent switches from checked to undefined and
grandparent is also checked, it also needs to switch to undefined)

e clicking on a parent which is in "undefined" does not change its state but should (either going to checked or unchecked,
because also all its children switch to this state

Related issues:

Related to EDIT - bug #6297: [Overview] BGBM User group wishes 2017 New

Related to EDIT - feature request #7793: Master ticket for E+M editor issues Closed
Related to EDIT - feature request #7235: Make available area vocabularies a d... Closed
Related to EDIT - task #7854: Open issues in TaxDistributionEditor Closed
Related to EDIT - feature request #7912: Enhance checkbox tree viewer Closed
Copied from EDIT - bug #6159: improve distribution editor in TaxEditor Closed
Associated revisions

Revision 1a7fff5e - 11/10/2017 02:40 PM - Katja Luther

ref #7063: fix gray and checked marks in area tree

Revision 7a440129 - 01/08/2018 01:17 PM - Katja Luther
ref #7063: sort terms by label

Revision 4f25e642 - 09/27/2018 03:42 PM - Katja Luther

ref #7063: add vocabulary selection for distribution editor and area selection in editor

Revision 9c8494ea - 09/27/2018 03:51 PM - Katja Luther

ref #7063: fix preselection of vocabulary

Revision 0483113 - 09/28/2018 03:18 PM - Katja Luther

ref #7063:fix that the last selection always appears in next field in distribution editor

Revision aff7bab0 - 09/28/2018 03:18 PM - Katja Luther

ref #7063:fix that the last selection always appears in next field in distribution editor

Revision 1d76231c - 10/01/2018 01:52 PM - Katja Luther

ref #7063: better handling of preferences for distribution editor and other places

Revision be7068cc - 10/02/2018 11:49 AM - Katja Luther

ref #7063:handle orderedTerms without orderindex and order by lable

Revision fc9¢c0563 - 10/02/2018 11:49 AM - Katja Luther

ref #7063:handle orderedTerms without orderindex and order by lable

Revision 3a77d114 - 10/02/2018 02:42 PM - Katja Luther

ref #7063: work in progress: selection in treeview of namedAreas for distribution editor should be more reasonable

Revision 61cd8ee1 - 10/04/2018 10:37 AM - Katja Luther

ref #7063: optimise setGrayed and check children in distribution selection wizard

Revision 5642c43a - 10/04/2018 10:37 AM - Katja Luther

ref #7063: optimise setGrayed and check children in distribution selection wizard

Revision eb82a77d - 10/04/2018 04:18 PM - Katja Luther

ref #7063: add base element to named area tree in selection wizard to provide the posibility to check this and/or the elements of it

Revision f53701cb - 10/16/2018 02:24 PM - Katja Luther
ref #7063: fix NPE in local preferences

Revision 84f5eea0 - 10/16/2018 03:28 PM - Katja Luther
ref #7063: fix NPE in distribution editor

Revision 925bbb39 - 10/23/2018 05:21 PM - Andreas Miiller

ref #7063 change label for distribution area selection button

Revision 789f987c¢ - 10/23/2018 06:30 PM - Andreas Miiller

ref #7063 remove "Base -" from area label for parent areas (was not intuitive)

Revision abfc6b6e - 10/23/2018 07:24 PM - Andreas Miiller
ref #7063 change labels for dialog help

03/20/2024

2/5



History

#1 - 11/07/2017 12:00 PM - Andreas Miiller

- Subject changed from improve the area selection wizard for sistribution editor to improve the area selection wizard for distribution editor

#2 - 11/08/2017 09:38 AM - Katja Luther

The area selection wizard works better now then before. Some minor issues:

¢ Handling of triple states: if only parts of a vocabulary are selected | would expect a triple state. As the vocabulary itself is not an area, it should
only show the state of the selected areas within this vocabulary, with (1) selected = all areas selescted, (2) undefined = some areas selected, (3)
unselected = no area selected. | managed to get such an "undefined" state once for the Waterbody vocabulary, but could not reproduce for any
other. This is different for parent nodes which are areas themselves. They must not have a triple state because they might be shown or not
shown in the editor.

The performance of e.g. clicking on TDWG vocabulary is very bad. Probably it is not a use case to select ALL TDWG areas. We may think for a
better solution. Maybe it is enough to only select the next layer (e.g. TDWG level 1) and one has to select the next level manually, but this has
also drawbacks, so we have to further think about a good solution

#3 - 11/08/2017 09:43 AM - Andreas Miiller
- Copied from feature request #6595: Migrate name editor added

#4 - 11/08/2017 09:44 AM - Andreas Miiller
- Copied from deleted (feature request #6595: Migrate name editor)

#5 - 11/08/2017 09:45 AM - Andreas Miiller
- Copied from bug #6159: improve distribution editor in TaxEditor added

#6 - 12/05/2017 02:02 PM - Andreas Miiller
- Target version changed from Release 4.12 to Release 4.13
#7 - 12/12/2017 01:48 PM - Katja Luther
Katja Luther wrote:
The area selection wizard works better now then before. Some minor issues:

e Handling of triple states: if only parts of a vocabulary are selected | would expect a triple state. As the vocabulary itself is not an area, it
should only show the state of the selected areas within this vocabulary, with (1) selected = all areas selescted, (2) undefined = some areas
selected, (3) unselected = no area selected. | managed to get such an "undefined" state once for the Waterbody vocabulary, but could not
reproduce for any other. This is different for parent nodes which are areas themselves. They must not have a triple state because they
might be shown or not shown in the editor.

this is partly implemented by checkmark if all areas of a vocabulary are selected and a grayed if only some areas are selected. It is not possible

to select a parent node which is an area and deselect the children or select only some of the children (then the parent node is not displayed in
distribution editor)

#8 - 01/08/2018 01:23 PM - Katja Luther

- Status changed from New to In Progress

for better usabilty the terms are sorted now

#9 - 02/13/2018 03:16 PM - Katja Luther

- Target version changed from Release 4.13 to Release 4.14

#10 - 02/16/2018 02:07 PM - Katja Luther

- Target version changed from Release 4.14 to Release 5.0

the grayed check boxes for larger hierarchies needs to be improved

#11 - 02/21/2018 11:31 AM - Andreas Miiller
- Related to bug #6297: [Overview] BGBM User group wishes 2017 added
#12 - 05/17/2018 04:23 PM - Katja Luther
- Target version changed from Release 5.0 to Release 5.1

- % Done changed from 0 to 40

#13 - 05/28/2018 12:01 PM - Andreas Miiller
- Estimated time set to 8:00 h

#14 - 06/28/2018 09:08 AM - Katja Luther

- Target version changed from Release 5.1 to Release 5.2

#15 - 08/17/2018 03:54 PM - Andreas Miiller

- Target version changed from Release 5.2 to Release 5.3

#16 - 09/06/2018 01:19 PM - Katja Luther

- Target version changed from Release 5.3 to Release 5.4

#17 - 09/27/2018 03:44 PM - Katja Luther

now the admin can define the vocabulary and in the distribution editor itself the shown areas can be defined.

#18 - 10/23/2018 10:52 AM - Andreas Miiller
- Status changed from In Progress to Resolved

- Assignee changed from Katja Luther to Andreas Miiller

A lot of work on this has been done in #7793. | put to resolved to check if all issues reported here are resolved now.

#19 - 10/23/2018 10:52 AM - Andreas Miiller

- Related to feature request #7793: Master ticket for E+M editor issues added

#20 - 10/23/2018 05:10 PM - Andreas Miiller

- Related to feature request #7235: Make available area vocabularies a database preference for TaxEditor distribution editor added

#21 - 10/23/2018 06:08 PM - Andreas Miiller

- Related to task #7854: Open issues in TaxDistributionEditor added

#22 - 10/23/2018 06:12 PM - Andreas Miiller

Performance has been improved by preselecting vocabularies in DB prefs or local prefs.

#23 - 10/23/2018 06:36 PM - Andreas Miiller
- Description updated

- Status changed from Resolved to Feedback

#24 - 10/23/2018 06:44 PM - Andreas Miiller

| updated description to refelct our decisions how the selection tree should work

#25 - 10/23/2018 06:57 PM - Andreas Miiller
- Description updated

#26 - 10/23/2018 07:00 PM - Andreas Miiller
- Description updated

#27 - 10/23/2018 07:13 PM - Andreas Miiller
- Description updated

#28 - 10/23/2018 07:14 PM - Andreas Miiller

- Assignee changed from Andreas Miiller to Katja Luther
https://dev.e-taxonomy.eu/redmine/issues/7793

#29 - 12/19/2018 02:04 PM - Katja Luther
- Status changed from Feedback to Resolved
- Assignee changed from Katja Luther to Andreas Mdiller

| think this is solved with #7887.

Now the items in the tree have three states and it is possible to select and deselct all children of an item.

#30 - 02/04/2019 12:29 PM - Andreas Miiller

- Subject changed from improve the area selection wizard for distribution editor to Improve the area selection wizard for distribution editor

#31 - 02/04/2019 12:34 PM - Andreas Miiller

- Status changed from Resolved to Closed

- Assignee changed from Andreas Muiller to Katja Luther
- % Done changed from 40 to 100

Katja Luther wrote:

| think this is solved with #7887.

Now the items in the tree have three states and it is possible to select and deselct all children of an item.

I think it is #7912 (not 7887). However, the selection wizard works good now. Minor open issues will be handled in #7912. So we can close this ticket.

#32 - 02/04/2019 12:34 PM - Andreas Miiller

- Related to feature request #7912: Enhance checkbox tree viewer added
